/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
/***************************************************************************/
/*                  W O R T                  W O R T    */
/*                                                                         */
/***************************************************************************/
# ifndef MENU_H
# define MENU_H

//# include "common.hpp"
//# include "function.hpp"

# define F_SCHREI 1
# define F_MENU   2
# define F_FUNK   3
# define F_NUMER  4

void Sorry( void *d );
void Forsage( void *d );
//void *Calloc( int n, int s );

typedef struct MENU
{  char flag ;            /* 1-, 2- 3- 4-.  */
   char ret ;             /*   0- , 1 -  .  */
   void (*funk)(void *) ; /*   */
   void *data ;           /*    */
   struct MENU *next ;    /*   */
   char *name ;           /*   */
}  MENU ;

/* ----------------------------------------------------------------------- */
extern MENU *file_menu_r ;
extern MENU  wort_menu_r[] ;

void  menu( void );
void  init_menu( void );
void  null_menu( void );

# endif




