/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
/***************************************************************************/
/*                  W O R T                  W O R T    */
/*                                                                         */
/***************************************************************************/
# include "define.h"
# ifdef __DOS__
# include <conio.h>
# endif

# include <stdio.h>
# include <malloc.h>

# include "x_schone.h"
# include "main.h"
# include "menu.h"

# define uchar   unsigned char
# define max(a,b)    (((a) > (b)) ? (a) : (b))
# define min(a,b)    (((a) < (b)) ? (a) : (b))

# define   h_menu_Farbe  0xf0
# define   h_curs_Farbe  0x1f
# define   v_menu_Farbe  0xf0
# define   v_curs_Farbe  0x1f

MENU *file_menu_r ;

MENU vorsage_menu_r[] =
{  { 3,0,Forsage       ,(void*)" " ,NULL," " },
   { 0,0,NULL          ,NULL          ,NULL,NULL          }
};
MENU wort_menu_r[] =
{  { 2,0,NULL,NULL,file_menu_r   ,""  },
   { 2,0,NULL,NULL,vorsage_menu_r,""},
   { 0,0,NULL,NULL,NULL          ,NULL       }
};

int    Symbol_H;      /*   */
Window Win ;

# define stop() {  short key1,key2 ; s_getch(&key1,&key2); }

/* ----------------------------------------------------------------------- */
typedef struct
{  short size_x,size_xx,size_y,
	 n_punkt,
	 *igrek ;
   MENU  *menu ;
}  form ;

static   char   *stek ;
static   short   SP ;
static   short  *mass_iks, *mass_igrek ;
static   char    Exist=0 ;

/* ----------------------------------------------------------------------- */

void   menu( void ) ;
void   init_menu( void ) ;
short  hor_menu( short igrek, MENU *menu ) ;
void   s_hor_menu( short igrek, short *iks, MENU *menu, short index ) ;
void   s_ver_menu( short igrek, short  iks, form F    , short index ) ;
short  ver_menu( short y,short x, MENU *menu ) ;
void   ver_menu_creat( form *f, MENU *menu ) ;
short  sehen_hor_menu( short **iks, MENU *menu ) ;
static short  schnell_taste( MENU *menu, uchar taste ) ;
void   sorry( short y, short x );

/* *********************************************************************** */
void menu( void )
{   short c ;

    if( Exist==0 ) init_menu( );
    hor_menu( 0, wort_menu_r ) ;
    SP=0 ;
}
/* ----------------------------------------------------------------------- */
void init_menu( void )
{
   short i ;
   short *a ;
   MENU  *menu ;

   stek       = (char  *)Calloc( 4000,1 ) ;
   mass_iks   = (short *)Calloc( 25,sizeof(short) ) ;
   mass_igrek = (short *)Calloc( 25,sizeof(short) ) ;

   a    = mass_iks ;
   menu = wort_menu_r ;
   a[0]=10 ;
   for( i=0 ; ; i++ )
   {  if( menu[i].flag==0 ) break ;

      char *Name=menu[i].name ;
      a[i+1]+=20+XTextWidth( Font0, Name,strlen( Name) );
   }
   Symbol_H = Symbol_H = Font0->ascent + Font0->descent ;

   SP=0 ;
   Exist=1 ;
}
/* ----------------------------------------------------------------------- */
short hor_menu( short igrek, MENU *menu )
{  short punkt=0,flag=0 ;
   static short key1,key2,key3 ;
   short size_Menu=2 ;
   short *iks=mass_iks ;

   while( 1 )
   {
       s_hor_menu( igrek,iks,menu,punkt ) ;

       key1=0 ; key2=0 ; key3=0 ;

       s_getch( &key1,&key2) ;

       switch( key2 )
       {   case S_key_Left: M_LINKS :
		if( punkt<=0 ) punkt=size_Menu-1 ; else punkt-- ;
		if( flag==1 && menu[punkt].flag==F_MENU )
		   key3=ver_menu( 1,iks[punkt], menu[punkt].next ) ;
		else
		   key3=0 ;
		break ;
	   case S_key_Right: M_RECHTS :
		if( punkt>=size_Menu-1 ) punkt=0 ; else punkt++ ;
		if( flag==1 && menu[punkt].flag==F_MENU )
		    key3=ver_menu( 1,iks[punkt], menu[punkt].next ) ;
		else
		   key3=0 ;
		break ;
	   case 0 :
	   switch( key1 )
	   {
		schnell :
		    s_hor_menu( igrek,iks,menu,punkt );

		case '\r' :
		   if( menu[punkt].flag==4 ){ return S_key_Esc ; }
		   if( menu[punkt].flag==3 )
		   {   menu[punkt].funk( menu[punkt].data ) ;
		      return S_key_Esc ;
		   }
		   if( menu[punkt].flag==2 )
		   {   flag=1 ;
		       key3=ver_menu( 1,iks[punkt], menu[punkt].next ) ;
		   }
		   break ;
	       case S_key_Esc : return S_key_Esc ;
	       default :
		   {   short p1 ;
		       p1=schnell_taste( menu,key1 ) ;
		       if( 0<=p1 ) {  punkt=p1 ; goto schnell ;  }
		   }
		   break ;
	   }
       }
       switch( key3 )
       {   case S_key_Left : goto M_LINKS ;
	   case S_key_Right: goto M_RECHTS ;
	   case S_key_Esc  : return S_key_Esc ;
       }
   }
}
/* ----------------------------------------------------------------------- */
short ver_menu( short y,short x, MENU *menu )
{  short punkt=0,ret ;
   static short key1,key2 ;
   form  f ;
   short i ;

   ver_menu_creat( &f,menu ) ;

   while( 1 )
   {
       paint( );
       s_ver_menu( 1,x,f,punkt ) ;

       s_getch( &key1,&key2 ) ;

       switch( key2 )
       {   case S_key_Up:
		if( punkt<=0 ) punkt=f.n_punkt-1 ; else punkt-- ; break ;
	   case S_key_Down:
		if( punkt>=f.n_punkt-1 ) punkt=0 ; else punkt++ ; break ;
	   case S_key_Left : ret = S_key_Left ;   goto ENDE ;
	   case S_key_Right: ret = S_key_Right ;  goto ENDE ;
	   case 0 :
	       switch( key1 )
	       {   case '\r' :
	   schnell :   i=f.igrek[punkt] ;
		       if( menu[i].flag==4 ){  ret = S_key_Esc ;  goto ENDE ; }
		       if( menu[i].flag==3 )
		       {   menu[i].funk( menu[i].data ) ;
			   ret = S_key_Esc ;  goto ENDE1 ;
		       }
		       if( menu[i].flag==2 )
		       {   ver_menu( i,x, menu[punkt].next ) ;
			   break ;
		       }
		   default :
		       {   short p1 ;
			   p1=schnell_taste( menu,key1 ) ;
			   if( 0<=p1 ) {  punkt=p1 ; goto schnell ;  }
		       }   break ;
	       }
	   case S_key_Esc : ret = S_key_Esc ; goto ENDE ;
       }
   }
ENDE  :
ENDE1 : return ret ;
}
/* ----------------------------------------------------------------------- */
short schnell_taste( MENU *menu,uchar taste )
{  short i,j ;
   uchar c ;

   for( i=0 ; menu[i].flag!=0 ; i++ )
   {   for( j=0 ; ; j++ )
       {   c=menu[i].name[j] ;
	   if( c==0 ) break ;
	   if( (uchar)''<=c && c<=(uchar)'' )
	   {   if( c==taste ) return i ;
	       //if( XLAT[c]==XLAT[taste] ) return i ;
	       break ;
	   }
       }
   }
   return -1 ;
}
/* ----------------------------------------------------------------------- */
void null_menu( void )
{
   if( Exist==0 ) init_menu( );
   s_hor_menu( 0,mass_iks,wort_menu_r,-1 ) ;
}
/* ----------------------------------------------------------------------- */
void s_hor_menu( short igrek, short *iks,MENU *menu, short index )
{  short i ;
   short Size_X,Size_Y ;

   ss_get_size( &Size_X,&Size_Y );
   if( Exist==0 ) init_menu( );
   t_GC GC1( Win,15,15 );
   XSetFont( Dis, GC1.GC1, Font0->fid );

   GC1.FillRectangle( 0, 0, Size_X,30 );
   GC1.SetForeground( 0 );
   for( i=0 ; i<25 ; i++ )
   {
      if( menu[i].flag==0 ) break ;
      if( i==index )
      {   GC1.SetForeground( 15 ); GC1.SetBackground( 1 );  }
      GC1.DrawImageString( mass_iks[i],25, menu[i].name );
      if( i==index )
      {   GC1.SetForeground( 0 ); GC1.SetBackground( 15 );  }
   }
}
/* ----------------------------------------------------------------------- */
void s_ver_menu( short igrek, short iks, form F, short index )
{  short i,x ;

   t_GC GC1( Win,15,15 );
   XSetFont( Dis, GC1.GC1, Font0->fid );
   x=iks ;
   GC1.FillRectangle( x, 30, F.size_xx+20,30+Symbol_H*(F.size_y-1) );
   GC1.SetForeground( 0 );
   GC1.DrawRectangle( x+2, 32, F.size_xx+15,25+Symbol_H*(F.size_y-1) );

   GC1.SetForeground( 0 ); GC1.SetBackground( 15 );
   for( i=0 ; i<25 ; i++ )
   {
      if( F.menu[i].flag==0 ) break ;
      if( i==index )
      {   GC1.SetForeground( 15 ); GC1.SetBackground( 1 );  }
      GC1.DrawImageString( x+10,35+Symbol_H*(i+1), F.menu[i].name );
      if( i==index )
      {   GC1.SetForeground( 0 ); GC1.SetBackground( 15 );  }
   }
}
/* ----------------------------------------------------------------------- */
void ver_menu_creat( form *f, MENU *menu )
{  short i,i1,j,s,*igrek ;

   for( i=0 ; i<25 ; i++ ) if( menu[i].flag==0 ) break ;
   f->size_y=i ;

   igrek = mass_igrek ;
   short ss=0 ;
   for( s=j=0,i=0 ; i<f->size_y ; i++ )
   {  if( menu[i].flag==0 ) break ;
      for( i1=0 ; i1<25 ; i1++ )
	 if( menu[i].name[i1]==0 ) break ;
      if( i1>s ) s=i1 ;
      if( menu[i].flag==2 || menu[i].flag==3 || menu[i].flag==4 )
	  igrek[j++]=i ;
      ss=max( ss,XTextWidth( Font0,menu[i].name,s ) );
   }
   t_GC GC1( Win,7,15 );
   GC1.FillRectangle( 20, 30, 20+ss,30+Symbol_H*f->size_y );

   f->size_x =s ;    f->n_punkt=j ;
   f->size_xx=ss ;
   f->igrek=igrek ;  f->menu=menu ;
}
/* ----------------------------------------------------------------------- */
void Sorry( void *d ){  ;  }
/* ----------------------------------------------------------------------- */
void Forsage( void *d )
{  short sx,sy,y,s1,s2,s3 ;
   short Size_X,Size_Y ;

   ss_get_size( &Size_X,&Size_Y );
   t_GC GC1( Win,15,15 );
   XSetFont( Dis, GC1.GC1, Font0->fid );

   sx=0 ;
   sx=max( sx,s1=XTextWidth( Font0, "  ",17 ) );
   sx=max( sx,s2=XTextWidth( Font0, "  ..",14 ) );
   sx=max( sx,s3=XTextWidth( Font0, "25  2000 .",16 ) );
   sy=3*Symbol_H ;

   GC1.FillRectangle( (Size_X-sx)/2-10, (Size_Y-sy)/2-10, sx+20,sy+20 );
   GC1.SetForeground( 0 );
   GC1.DrawRectangle( (Size_X-sx)/2-5,  (Size_Y-sy)/2-5,  sx+10,sy+10 );

   y=(Size_Y-sy)/2 ;
   GC1.DrawImageString( (Size_X-s1)/2, y+1*Symbol_H, "  "  );
   GC1.DrawImageString( (Size_X-s2)/2, y+2*Symbol_H, "  .."  );
   GC1.DrawImageString( (Size_X-s3)/2, y+3*Symbol_H, "25  2000 ."  );
   stop();
}



