/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef S_KEY_DEFINED
#define S_KEY_DEFINED

# include "define.h"
/************** ।  */

# ifdef __X__

   /* ------------ 㭪樮x ------------ */
   #define S_key_F1   15104
   #define S_key_F2   15360
   #define S_key_F3   15616
   #define S_key_F4   15872
   #define S_key_F5   16128
   #define S_key_F6   16384
   #define S_key_F7   16640
   #define S_key_F8   16896
   #define S_key_F9   17152
   #define S_key_F10  17408
   #define S_key_AF1  26624
   #define S_key_AF2  26880
   #define S_key_AF3  27136
   #define S_key_AF4  27392
   #define S_key_AF5  27648
   #define S_key_AF6  27904
   #define S_key_AF7  28160
   #define S_key_AF8  28416
   #define S_key_AF9  28672
   #define S_key_AF10 28928
   #define S_key_SF1  21504
   #define S_key_SF2  21760
   #define S_key_SF3  22016
   #define S_key_SF4  22272
   #define S_key_SF5  22528
   #define S_key_SF6  22784
   #define S_key_SF7  23040
   #define S_key_SF8  23296
   #define S_key_SF9  23552
   #define S_key_SF10 23808

/* ---------- ࠢ, ஢ ----------- */
   #define S_key_Esc      27
   #define S_key_Enter  '\r'
   #define S_key_TabL   3840
   #define S_key_TabR   3849
   #define S_key_Back      8
   #define S_key_Ins   20992
   #define S_key_Del   21248
   #define S_key_Home  18176
   #define S_key_End   20224
   #define S_key_PgUp  18688
   #define S_key_PgDn  20736
   #define S_key_Left  19200
   #define S_key_Right 19712
   #define S_key_Up    18432
   #define S_key_Down  20480
   #define S_key_N1      561
   #define S_key_N2      818

   #define S_key_Alt_Ins     S_key_Ins
   #define S_key_Alt_Del     S_key_Del
   #define S_key_Alt_Home    S_key_Home
   #define S_key_Alt_End     S_key_End
   #define S_key_Alt_PgUp    S_key_PgUp
   #define S_key_Alt_PgDn    S_key_PgDn
   #define S_key_Alt_Left    S_key_Left
   #define S_key_Alt_Right   S_key_Right
   #define S_key_Alt_Up      S_key_Up
   #define S_key_Alt_Down    S_key_Down


   #define S_key_1     '1'
   #define S_key_2     '2'
   #define S_key_3     '3'
   #define S_key_4     '4'
   #define S_key_5     '5'
   #define S_key_6     '6'
   #define S_key_7     '7'
   #define S_key_8     '8'
   #define S_key_9     '9'
   #define S_key_0     '0'
   #define S_key_plus  '+'
   #define S_key_minus '-'

/* -------- 㪢 ----------- */
   #define S_key_Q   'Q'
   #define S_key_W   'W'
   #define S_key_E   'E'
   #define S_key_R   'R'
   #define S_key_T   'T'
   #define S_key_Y   'Y'
   #define S_key_U   'U'
   #define S_key_I   'I'
   #define S_key_O   'O'
   #define S_key_P   'P'
   #define S_key_A   'A'
   #define S_key_S   'S'
   #define S_key_D   'D'
   #define S_key_F   'F'
   #define S_key_G   'G'
   #define S_key_H   'H'
   #define S_key_J   'J'
   #define S_key_K   'K'
   #define S_key_L   'L'
   #define S_key_Z   'Z'
   #define S_key_X   'X'
   #define S_key_C   'C'
   #define S_key_V   'V'
   #define S_key_B   'B'
   #define S_key_N   'N'
   #define S_key_M   'M'
   #define S_key_quest '?'
   #define S_key_q   'q'
   #define S_key_w   'w'
   #define S_key_e   'e'
   #define S_key_r   'r'
   #define S_key_t   't'
   #define S_key_y   'y'
   #define S_key_u   'u'
   #define S_key_i   'i'
   #define S_key_o   'o'
   #define S_key_p   'p'
   #define S_key_a   'a'
   #define S_key_s   's'
   #define S_key_d   'd'
   #define S_key_f   'f'
   #define S_key_g   'g'
   #define S_key_h   'h'
   #define S_key_j   'j'
   #define S_key_k   'k'
   #define S_key_l   'l'
   #define S_key_z   'z'
   #define S_key_x   'x'
   #define S_key_c   'c'
   #define S_key_v   'v'
   #define S_key_b   'b'
   #define S_key_n   'n'
   #define S_key_m   'm'
   #define S_key_space ' '

/* ------------------ 㦥 ------------------ */
   #define S_Shift_L  0x20
   #define S_Ctrl_L   0x10
   #define S_Alt_L    0x08
   #define S_Alt_R    0x04
   #define S_Ctrl_R   0x02
   #define S_Shift_R  0x01

# endif

# ifdef  __DOS__
   # define  __DOS_or_OS_2__
# endif
# ifdef  __OS_2__
   # define  __DOS_or_OS_2__
# endif

# ifdef  __DOS_or_OS_2__

   #define S_key_F1   59
   #define S_key_F2   60
   #define S_key_F3   61
   #define S_key_F4   62
   #define S_key_F5   63
   #define S_key_F6   64
   #define S_key_F7   65
   #define S_key_F8   66
   #define S_key_F9   67
   #define S_key_F10  68

/* ---------- ࠢ, ஢ ----------- */
   #define S_key_Esc    27
   #define S_key_Enter '\r'
   #define S_key_TabL   3840
   #define S_key_TabR   '\t'
   #define S_key_Back   8
   #define S_key_Ins    82
   #define S_key_Del    83
   #define S_key_Home   71
   #define S_key_End    79
   #define S_key_PgUp   73
   #define S_key_PgDn   81
   #define S_key_Left   75
   #define S_key_Right  77
   #define S_key_Up     72
   #define S_key_Down   80

   #ifdef __DOS__
      #define S_key_Ctrl_Ins    S_key_Ins
      #define S_key_Ctrl_Del    S_key_Del
      #define S_key_Ctrl_Home   S_key_Home
      #define S_key_Ctrl_End    S_key_End
      #define S_key_Ctrl_PgUp   S_key_PgUp
      #define S_key_Ctrl_PgDn   S_key_PgDn
      #define S_key_Ctrl_Left   S_key_Left
      #define S_key_Ctrl_Right  S_key_Right
      #define S_key_Ctrl_Up     S_key_Up
      #define S_key_Ctrl_Down   S_key_Down

      #define S_key_Alt_Ins     S_key_Ins
      #define S_key_Alt_Del     S_key_Del
      #define S_key_Alt_Home    S_key_Home
      #define S_key_Alt_End     S_key_End
      #define S_key_Alt_PgUp    S_key_PgUp
      #define S_key_Alt_PgDn    S_key_PgDn
      #define S_key_Alt_Left    S_key_Left
      #define S_key_Alt_Right   S_key_Right
      #define S_key_Alt_Up      S_key_Up
      #define S_key_Alt_Down    S_key_Down
   #endif

   #ifdef __OS_2__
      #define S_key_Ctrl_Ins    146
      #define S_key_Ctrl_Del    147
      #define S_key_Ctrl_Home   119
      #define S_key_Ctrl_End    117
      #define S_key_Ctrl_PgUp   132
      #define S_key_Ctrl_PgDn   118
      #define S_key_Ctrl_Left   115
      #define S_key_Ctrl_Right  116
      #define S_key_Ctrl_Up     141
      #define S_key_Ctrl_Down   145

      #define S_key_Alt_Ins     162
      #define S_key_Alt_Del     163
      #define S_key_Alt_Home    200   //153   //159
      #define S_key_Alt_End     159   //161   //153
      #define S_key_Alt_PgUp    153   // 158   //161
      #define S_key_Alt_PgDn    161   //159   //158
      #define S_key_Alt_Left    155
      #define S_key_Alt_Right   157
      #define S_key_Alt_Up      152
      #define S_key_Alt_Down    160
   #endif

   #define S_Shift_L  0x20
   #define S_Ctrl_L   0x10
   #define S_Alt_L    0x08
   #define S_Alt_R    0x04
   #define S_Ctrl_R   0x02
   #define S_Shift_R  0x01

# endif

# endif
