/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
# ifndef SCHONE_H
# define SCHONE_H

# include <X11/Xlib.h>
# include <X11/Xutil.h>
# include <X11/Xos.h>
# include <X11/keysym.h>
# include <X11/Intrinsic.h>
# include <X11/StringDefs.h>

// --------------------   -------------------------------
class t_GC
{
public :
   GC     GC1 ;

	  t_GC( Window Win );
	  t_GC( Window Win, ulong Color1, ulong Color2 );
	 ~t_GC( void );
   void   SetForeground( ulong Color );
   void   SetBackground( ulong Color );
   void   DrawImageString( short x, short y, char *Text );
   void   DrawLine( int x1, int y1, int x2, int y2 );
   void   FillRectangle( int x1, int y1, int x2, int y2 );
   void   DrawRectangle( int x1, int y1, int x2, int y2 );
};

extern Display     *Dis ;
extern Window       Win ;

void   ss_get_size( short *Size_X, short *Size_Y );


# include "define.h"
# include "s_defkey.h"

   #define uchar unsigned char

/* ----------------------------------------------------------------------- */
   void   s_begin_schone( void );
   void   s_begin_schone( int argc, char *argv[] );
   void   s_nacht( void );
   void   s_set_size( short sx, short sy );

   void   s_text_yxf(  short y, short x, uchar f, char *str );
   void   s_text_yxf1( short y, short x, uchar f, char *str );
   void   s_text_yxfl( short y, short x, uchar f, short L, char *str );
   void   s_text_yx( short y, short x, char *str );
   void   s_farbe_yxt( short y, short x, uchar *t, char *str );

   void   s_rame1_f( short y1, short x1, short y2, short x2, uchar f );
   void   s_rame1_F( short y1, short x1, short y2, short x2, uchar f );
   void   s_rame2_f( short y1, short x1, short y2, short x2, uchar f );
   void   s_rame2_F( short y1, short x1, short y2, short x2, uchar f );

   void   s_save     ( short y1, short x1, short y2, short x2 );
   void   s_save_rame( short y1, short x1, short y2, short x2 );
   void   s_restore( void );

   void   s_redraw( void );
   void   s_redraw_str( short y );

   short  s_line_screen( void );
   short  s_clear_cursor( void );
   short  s_set_cursor( short S );
   short  s_set_cursor1( short s );
   void   s_goto_xy( short y,short x );
   void   s_getch( short *,short *) ;

   void   s_set_43_line( char f );
   int    s_shiftstatus( void );
//   int    s_tst_event( void ) ;

# endif
