# ifndef SCHONE_X_H
# define SCHONE_X_H

# include <X11/Xatom.h>
# include <X11/Xlib.h>
# include <X11/Xutil.h>
# include <X11/Xos.h>
# include <X11/keysym.h>
# include <X11/Intrinsic.h>
# include <X11/StringDefs.h>
# include "s_defkey.h"

// --------------------   -------------------------------
class t_GC
{
//   Window Win ;
public :
   GC     GC1 ;

	  t_GC( Window Win );
	  t_GC( Window Win, ulong Color1, ulong Color2 );
	 ~t_GC( void );
   void   SetForeground( ulong Color );
   void   SetBackground( ulong Color );
   void   DrawImageString( short x, short y, char *Text );
   void   DrawLine( int x1, int y1, int x2, int y2 );
   void   FillRectangle( int x1, int y1, int x2, int y2 );
   void   DrawRectangle( int x1, int y1, int x2, int y2 );
};

extern Display  *Dis ;
extern int       i_Scr ;
//extern Window    Win ;
extern short        Size_X,Size_Y ;

void   ss_get_size( short *X, short *Y );
void   s_getch( short *taste1, short *taste2 );

# endif

